#------------------------------------------------------------------------------------------------
#SECTION 1: Importing Libraries and Setting Up Pins
import cv2
import numpy as np
import RPi.GPIO as GPIO

GPIO.setwarnings(False)

# INSERT CODE HERE: Set variable for servoPin
# INSERT CODE HERE: Set GPIO mode to GPIO.BCM
# INSERT CODE HERE: Set servoPin as GPIO.OUT

pwm = GPIO.PWM(servoPin, 100)

#------------------------------------------------------------------------------------------------
#SECTION 2: USB Camera Setup

# INSERT CODE HERE: Initialize video capture object as 'camera', connecting to the first USB camera
# INSERT CODE HERE: Set the width of the camera's captured video frame to 640 pixels
# INSERT CODE HERE: Set the height of the camera's captured video frame to 480 pixels

#------------------------------------------------------------------------------------------------
#SECTION 3: Image Processing
while True:
    ret, frame = camera.read()  # Read frame from the camera
    if not ret:
        break

    hsvFrame = cv2.cvtColor(frame, cv2.COLOR_BGR2HSV)  # Convert from BGR to HSV

    red_lower = np.array([160, 70, 50])  # Define boundaries for Red
    red_upper = np.array([180, 255, 255])
    red_mask = cv2.inRange(hsvFrame, red_lower, red_upper)  # Threshold HSV image to identify only Red
    result_red = cv2.bitwise_and(frame, frame, mask=red_mask)  # Bitwise-AND original image with mask

	# GREEN COLOR DETECTION:
	# INSERT CODE: Define green lower boundary
   	# INSERT CODE: Define green upper boundary
   	# INSERT CODE: Create green mask
   	# INSERT CODE: Use bitwise_and to isolate green color from the video

	# RESULT:
	# INSERT CODE: Combine the results so both red and green colors are isolated from the video
   	# INSERT CODE: Display the final result

    #------------------------------------------------------------------------------------------------
    #SECTION 4: Servo Control
    #when q is pressed, the image seen is checked for red and green presence. cv2.watKey(5) makes the frame pause for 5 ms
    if cv2.waitKey(5) & 0xFF == ord('q'):
        if (cv2.countNonZero(red_mask) > cv2.countNonZero(green_mask)) and cv2.countNonZero(
                red_mask) > (0.25 * 640 * 480):
            print('Red detected')
        #INSERT CODE: Start clockwise rotation; dutycycle = 5

        elif (cv2.countNonZero(green_mask) > cv2.countNonZero(red_mask)) and cv2.countNonZero(
                green_mask) > (0.25 * 640 * 480):
            print('Green detected')
        	#INSERT CODE: Start counterclockwise rotation; dutycycle = 55

        else:
            print('Neither red nor green detected')
        	#INSERT CODE: Stop servo rotation

        print('------------------------')
GPIO.cleanup()
cv2.destroyAllWindows()

